CreateBtrue <- function( n, sparsity, acyclic ) 
{
  # Create the Btrue matrix
  Btrue <- matrix( (runif(n*n)<(sparsity/100))*1, n, n )
  diag(Btrue) <- 0
  
  # If it was requested that the true model is acyclic, then make it 
  # such (also permute variables to make sure that 1...n isn't a guaranteed
  # valid causal order)
  if (acyclic)
  {
    Btrue[upper.tri(Btrue)] <- 0
    varorder <- sample.int( n, n )
    Btrue <- Btrue[varorder, varorder]
  }

  Btrue
}

