
#define ForwardPath 0
#define BackwardPath 1
#define BidirPath 2
#define UndirPath 3


void InitEdgeIndex( int nvars, matrix E );
int GetMaxPathLength( void );
void PrintEdgeIndex( void );
int DirectEdgeToIndex( int from, int to );
int ConfounderEdgeToIndex( int from, int to );
int GetIndexToEdgeTableElement( int i, int j );

long long GetOrigDirEdge(int x, int y);
long long GetOrigConfEdge(int x, int y);
long long GetExpDirEdge(int x, int y, int ei);
long long GetExpConfEdge(int x, int y, int ei);
long long GetExpDsep(long long ii, int ei);
long long GetExpPath(int pathtype, int x, int y, int length, long long si, int ei);
long long GetTotalEffect(int x, int y);
long long GetTotalEffectPath(int x, int y, int length);

void CheckXnotequalY( int x, int y );
void CheckXlessthanY( int x, int y );
void CheckXlessthanorequaltoY( int x, int y );
void Checkx( int x );
void Checkii( long long ii );
void Checksi( long long si );
void Checklength( int length );
void Checkei( int ei );
long long GetCondSet( long long ii );

void WriteTotalEffectConstraints( void );
void WriteAcyclicityConstraints( void );
void WriteNoConfoundersConstraints( void );

void WriteSpecificDseps( long long ii, int ei, int isindep );
void WriteSpecificConstraints( long long ii, int ei );
