
// basic matrix structure. note that the elements are scanned columnwise,
// so the first column comes first (from top to bottom), then the second
// column, and so on. rows and columns indexed with 0 as initial index
typedef struct {
  int *contents;
  int rows;
  int cols;
} matrix;

// macro for quickly accessing an element (no actual function call), 
// both getting the value and setting it is possible with this
#define el(M,r,c) ((M).contents[((c)*((M).rows)) + (r)])

// functions for initializing, destroying, and printing a matrix
matrix CreateMatrix( int r, int c, int val );
void SetMatrix( matrix M, int val );
matrix CopyMatrix( matrix M );
void RemoveMatrix( matrix M );
int IdenticalMatrix( matrix M1, matrix M2 );
void SetRformat( int setrformat );
void PrintMatrix( char *msg, matrix M );
void PrintTransposeMatrix( char *msg, matrix M );

