#ifndef discoverer_minisatbb3api_h
#define discoverer_minisatbb3api_h


// --- public function prototypes ---

// starts up and initializes the minisatbb3 process
void satinit( const char *reordertype );

// begins a LOAD operation
void satload( void );

// adds a constraint
void satconstraint( const int n, const long long * vars );

// ends a LOAD operation
void satloadend( void );

// performs a SOLVE operation
int satsolve( const int n, long long * vars );

// performs a BACKBONE operation
int satbackbone( const int n, long long * vars );

// instructs the minisatbb3 process to QUIT
void satquit( void );

// converts from long long array to character string
int satarray2string( int n, const long long *vars, int maxlen, char *str );

// converts from character string to long long array
int satstring2array( int *n, long long *vars, const char *str );

// --- internal function prototypes ---

// reads a line of the response
int readresponseline( char *readbuf, int maxlen, FILE *source, int waitsecs );

// writes a command
int satwritecommand( const char * str );

// waits for a OK response
int satwaitresponse( int cmdnum, int waitsecs );

// handles both SOLVE and BACKBONE
int satsolve_or_backbone( const int n, long long * vars, const int bbflag );



#endif
